use std::io::Write;

// on boucle sur toutes les coordonnees de carres
fn coordonnees_carres(
    largeur: u32,
    hauteur: u32,
    taille_carre: u32,
) -> impl Iterator<Item = (u32, u32)> {
    unimplemented!()
}

fn serpent<P: AsRef<std::path::Path>>(
    fichier: P,
    largeur: u32,
    hauteur: u32,
    taille_carre: u32,
) -> std::io::Result<()> {
    let mut svg = std::fs::File::create(fichier)?;
    writeln!(&mut svg, "<svg width='{}' height='{}'>", largeur, hauteur)?;
    coordonnees_carres(largeur, hauteur, taille_carre)
        .enumerate()
        .try_for_each(|(i, (x, y))| {
            writeln!(
                &mut svg,
                "<rect x='{}' y='{}' width='{}' height='{}' stroke='blue' fill='white'/>",
                x + taille_carre / 20,
                y + taille_carre / 20,
                taille_carre * 9 / 10,
                taille_carre * 9 / 10
            )?;
            writeln!(
                &mut svg,
                "<text x='{}' y='{}' text-anchor='middle'>{}</text>",
                x + taille_carre / 2,
                y + taille_carre / 2,
                i
            )
        })?;
    write!(&mut svg, "</svg>")
}

fn main() -> std::io::Result<()> {
    serpent("gros.svg", 900, 600, 80)?;
    serpent("petit.svg", 90, 600, 80)?;
    serpent("minuscule.svg", 90, 90, 80)?;
    serpent("vide.svg", 90, 90, 100)?;
    Ok(())
}
